
	ORG	3000H
;	m4mac/asm
PUTHL	MACRO	#P1
	LD	(HL),#P1
	INC	HL
	ENDM
;
;	Protocol switch macro
;
;	Expansion is something like:
;
;	CP	'D'
;	JR	NZ,SWAA
;	CALL	SDATA
;	JP	PROTO
;SWAA
;
SWITCH	MACRO	#P1,#P2
	CP	#P1
	JR	NZ,SW?
	CALL	#P2
	JP	PROTO
SW?
	ENDM
;
TOCHAR	MACRO
	ADD	A,32
	ENDM
;
STROUT	MACRO	#P1
	LD	DE,#P1
	CALL	PRTSTR
	ENDM
;
SPACKET	MACRO	#P1
	LD	A,#P1
	CALL	SPACK
	JP	ABORT
	ENDM
;
RPACKET	MACRO
	CALL	RPACK
	JP	QUIT
	ENDM
;
NSTATE	MACRO	#P1
	LD	A,#P1
	LD	(STATE),A
	ENDM
;
IFANOT	MACRO	#P1,#P2
	CP	#P1
	JR	NZ,#P2
	ENDM
;
IFALT	MACRO	#P1,#P2
	CP	#P1
	JR	C,#P2
	ENDM
;
IFAGE	MACRO	#P1,#P2
	CP	#P1
	JR	NC,#P2
	ENDM
;
IFA	MACRO	#P1,#P2
	CP	#P1
	JR	Z,#P2
	ENDM
;
IFZ	MACRO	#P1
	OR	A
	JR	Z,#P1
	ENDM
;
GENCASE	MACRO	#P1,#P2
	LD	A,#P2
	LD	(FLDLEN),A
	LD	A,#P1
	JP	GENCMD
	ENDM
;
GETHL	MACRO	#P1
	INC	HL
	LD	#P1,(HL)
	ENDM
;
ADDPUT	MACRO	#P1
	LD	A,(#P1)
	CALL	TCHPUT
	ENDM
;
SRPACK	MACRO	#P1
	LD	A,#P1
	CALL	SPACK
	JP	ABORT
	RPACKET
	ENDM
;
GETCRCTAB	MACRO
	LD	C,A
	LD	HL,CRCTAB
	ADD	HL,BC
	ADD	HL,BC
	ENDM
;
XORATHL	MACRO	#P1
	LD	A,#P1
	XOR	(HL)
	LD	#P1,A
	ENDM
;
CHKWKEY	MACRO	#P1
	IFA	#P1,INCHR5
	ENDM
;
IFNZ	MACRO	#P1
	OR	A
	JR	NZ,#P1
	ENDM
;
SETFLG	MACRO	#P1
	CALL	ONOFF
	LD	(#P1),A
	JP	KERMIT
	ENDM
;
SHOFFON	MACRO	#P1
	LD	A,(#P1)
	CALL	COFFON
	JP	NEWLIN
	ENDM
;
FOFFON	MACRO	#P1
	LD	A,(#P1)
	CALL	COFFON
	CALL	NEWLIN
	ENDM
;
SHRSTAT	MACRO	#P1,#P2
	FORMAT	#P1,SRSTRLEN
	LD	A,(#P2)
	CALL	ANOUT
	CALL	NEWLIN
	ENDM
;
SHSSTAT	MACRO	#P1,#P2
	FORMAT	#P1,SRSTRLEN
	LD	A,(#P2)
	CALL	ANOUT
	CALL	NEWLIN
	ENDM
;
DOSVC	MACRO	#P1
	LD	A,#P1
	RST	28H
	LD	(XERRNO),A
	RET
	ENDM
;
FORMAT	MACRO	#P1,#P2
	LD	HL,#P2
	LD	DE,#P1
	CALL	LEFTPAD
	ENDM
;
TRLOG	MACRO	#P1,#P2
	LD	HL,#P1
	CALL	OUTLOG
	JP	#P2
	ENDM
;
;	Decode the contents of the packet, and output them using
;	the function whose address is passed in HL
;
DECODE	LD	(OUTADDR),HL	;Save the output function
	PUSH	BC		;Save the registers that we use
	PUSH	DE
	PUSH	HL
	LD	HL,DATA		;Get the buffer address
	LD	(DATPTR),HL	;Set the address
	LD	C,A		;Get the length
	LD	B,0		;Make it 16 bits
	PUSH	HL		;Save DATPTR
	ADD	HL,BC		;Compute the end of the packet
	LD	(HL),0		;Put in the NULL byte
	POP	HL		;Get DATPTR back
;    end = buf + len;
;    while (buf < end) {
;if ( rptflg && (a == '~') ) {   /* got a repeat prefix? */
;	rep = unchar(*buf++);   /* Yes, get the repeat count, */
;	a = *buf++;             /* and get the prefixed character. */
;}
;else
;    rep = 1;
DECODE0	LD	A,1		;Set the repeat count
	LD	(RPTCNT),A
	LD	A,(HL)		;Get a character
	INC	HL		;Point to the next
	LD	C,A		;Store the value
	OR	A		;Is it NULL?
	JP	Z,DECODE40	;Quit the loop if it is
	LD	A,(RPTFLG)	;Is repeat prefixing on?
	IFZ	DECODE1
	LD	A,(RPTQ)	;Get the quote character
	IFANOT	C,DECODE1
	LD	A,(HL)		;Get the count + 32
	SUB	' '		;Make it the real count
	INC	HL		;Point to next character
	LD	(RPTCNT),A	;Save the repeat count
	LD	A,(HL)		;Get a character
	INC	HL		;Point to the next
	LD	C,A		;Save the character
;b8 = 0;                         /* Check high order "8th" bit */
;if ( flg8 && (a == qu8) ) {
;	b8 = 0200;
;	a = *buf++;             /* and get the prefixed character. */
;    }
DECODE1	XOR	A		;Set the initial eighth bit as ZERO
	LD	D,A
	LD	A,(EBQFLG)	;Is eighth bit quoting on?
	IFZ	DECODE2
	LD	A,(EBQ)		;Get the eighth bit quote character
	IFANOT	C,DECODE2
	LD	D,128		;Get an eighth bit
	LD	A,(HL)		;Get a character
	INC	HL		;Point to the next
	LD	C,A		;Save the character
;if (a == quote) {               /* If control prefix, */
;    a  = *buf++;                /* get its operand. */
;    a7 = a & 0177;              /* Only look at low 7 bits. */
;    if ((a7 >= 0100 && a7 <= 0137) || a7 == '?') /* Uncontrollify */
;    a = ctl(a);                 /* if in control range. */
;}
DECODE2	LD	A,(MYCTLQ)	;Get the control character quote
	IFANOT	C,DECODE5
	LD	A,(HL)		;Get a character
	INC	HL		;Point to the next
	LD	C,A		;Save the character
	AND	127		;Keep 7 bits
	LD	E,A		;Save only 7 bits worth
	LD	A,E		;Check lower bound of controls
	CP	'@'
	JP	M,DECODE3	;Jump if less than
	CP	96		;Check upper bound of controls
	JP	M,DECODE4
DECODE3	IFANOT	'?',DECODE5
DECODE4	LD	A,C		;Get the character
	SUB	64		;Subtract 64 to uncontrolify it
	AND	127
	LD	C,A		;Save the new value
;a |= b8;                        /* OR in the 8th bit */
DECODE5	LD	A,D		;Get the eighth bit
	OR	C		;Or in the character
	LD	C,A		;Save the new value
	LD	A,(RPTCNT)	;Get the repeat count
	LD	B,A		;Get it into the counter
;while (rep-- > 0) {
;    if (image == 0)            /*  if 7-bit            */
;	r = ascout(a);
;    else                        /*  prefixing / image   */
;	r = putc(a,fp);
;    if (r == EOF)               /* if error             */
;	error |= filerr();
;   }   }
DECODE8	LD	IX,RTRANS	;Get the pointer
	CALL	INCKTRANS	;Increment character counts
	LD	A,C		;Get the character
	CALL	PUTCH
	JR	NZ,DECODE50
	DJNZ	DECODE8		;Loop until done
	JP	DECODE0
DECODE40	EQU	$
	POP	HL		;Restore the stack
	POP	DE
	POP	BC
	RET
DECODE50	EQU	$
	CALL	XERROR0		;Print a system error message
	LD	A,1		;Set NZ status for return
	OR	A
	JR	DECODE40	;Join the exit code
XERROR0	EQU	$
PUTCH	EQU	$
RTRANS	EQU	$
INCKTRANS	EQU	$
RPTCNT	EQU	$
OUTADDR	EQU	$
DATA	EQU	$
DATPTR	EQU	$
RPTFLG	EQU	$
RPTQ	EQU	$
EBQFLG	EQU	$
EBQ	EQU	$
MYCTLQ	EQU	$
	DEFB	0
	END
